#ifdef IGNORE_ME
  #define ident "@(#) std_init.cc (/sccs/ri_util/src/s.std_init.cc) 1.2 02/24/99 14:20:45";
#endif

/* 
 * file:  std_init.h
 *
 * description:  standard configuration parser (for unix style resource files)
 *
 * revision list:
 *   Fri May  8 11:24:10 EDT 1998 KRB - created first version.
 *
 *
 */
  // std includes
#include <iostream.h>
#include <stdio.h>
#include <string.h>

  // our 'std' or 'library' includes
#include <stdinc.h>
#include <c_timestamp.h>
#include <c_string.h>
#include <c_hash.h>

  // proj specific includes
#include "std_init.h"

// i know this is ugly, but it's the fastest way I know how to do it...
// please note that this puts an upper limit of 4095 characters for the line size
// for the config files...
#define DEF_BUFF_LEN 4096

ostream& std_init_out = cout;

// localized functions...
int init_parse_line( char* line, c_string& key, c_string &value );


inline char* killnewline( char *s )
{
  char *p;

  p = strchr( s, '\n' );
  if(p) *p = '\0';

  p = strchr( s, '\r' );
  if(p) *p = '\0';

  return s;
}

int init_configure( const char* file_name, c_hash<c_string,c_string>& settings )
{
  FILE *fp;
  char *p;

  fp = fopen( file_name, "r" );
  if( NULL == fp ) {
    #if defined( _DEBUG )
      INFO(std_init_out) << "Error opening configuration file: " << file_name << endl;
    #endif
    return FALSE;
  }

  char* buff = new char[DEF_BUFF_LEN];
  c_string key, value;
  while( TRUE ) {
    if( NULL == fgets( buff, DEF_BUFF_LEN, fp ) ) {
      break;
    }

    killnewline(buff);

    // slurp lines that end with a '\\'
    p = buff + strlen(buff);
    while( '\\' == *p ) {
      #if defined( _DEBUG )
	      INFO(std_init_out) << "slurping line..." << endl;
      #endif
      if( NULL == fgets( p, buff - p, fp ) ) {
	      break;
      }
      killnewline(buff);
      p = buff + strlen(buff);
    }

    key.empty();
    value.empty();

    if( init_parse_line( buff, key, value ) ) {
      c_map_pair<c_string,c_string> pair(key,value);
      settings.add( pair );
    }
  }
  delete buff;

  return TRUE;
}

int init_parse_line( char* line, c_string& key, c_string &value )
{
  char *p, *p2;

  // error no data...
  if( '\0' == *line ) {
    return FALSE;
  }

  // remove any comments...
  p = strchr( line, '#' );
  if( NULL != p ) {
    *p = '\0';
  }

  p = line;
  if( '\0' == *p ) {
    return FALSE;
  }

  // skip any leading whitespace...
  while( *p != '\0' && (*p == ' ' || *p == '\t') ) p++;

  // if it's a comment, it's not a setting...
  if( '#' == *p ) {
    #if defined( _DEBUG )
      INFO(std_init_out) << "line was comment: " << line << endl;
    #endif
    return FALSE;
  }

  p2 = line;

  // get past initial witespace
  while( *p2 != '\0' && (*p2 == ' ' || *p2 == '\t') ) p2++;

  // get to the next whitespace
  while( *p2 != '\0' && (*p2 != ' ' && *p2 != '\t') ) p2++;
  *p2 = '\0';
  p2++;

  // find the next non-whitespace
  while( *p2 != '\0' && (*p2 == ' ' || *p2 == '\t') ) p2++;

  if( '\0' == *p || '\0' == *p2 ) {
    #if defined( _DEBUG )
      INFO(std_init_out) << "Eh, one of the two words is blank on line: " << line << endl;
    #endif
    return FALSE;
  }

  key = p;
  value = p2;

  return TRUE;
}




