#ifdef IGNORE_ME
  #define ident "@(#) str_ext.cc (/sccs/ri_util/src/s.str_ext.cc) 1.2 02/24/99 14:20:45";
#endif

/*  str_ext.cpp
  Copyright 1997 Kyle R. Burton

str_ext.cpp is free software; you can redistribute it and/or modify
it under the tearms of the GNU General Public License as published by 
the Free Software Foundation; either version 2, or (at your option)
any later version.

str_ext.cpp is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with str_ext.cpp; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/*
 * file:  str_ext.cpp
 *
 * purpose:  string manipulation functions
 *
 * created: Wed Oct  8 09:58:51 EDT 1997, Kyle R. Burton
 *
 * revision list:
 *
 */
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "str_ext.h"



/*
 * char* strlpad( char cPad, unsigned int nPadLen, char* szString )
 *
 *
 */
char* strlpad( char cPad, unsigned int nPadLen, char* szString )
{ // *b $FileName:$LineNumber
  int nLen = strlen( szString );
  char* pTmp1 = szString + nLen, *pTmp2 = szString + nPadLen;

  // shift the string up...
  while( pTmp1 >= szString ) {
    *pTmp2-- = *pTmp1--;
  }

  // fill the remainder with the pad...
  while( pTmp2 >= szString ) {
    *pTmp2-- = cPad;
  }

  return( szString );
}

/*
 * char* strrpad( char cPad, unsigned int nPadLen, char* szString )
 *
 */
char* strrpad( char cPad, unsigned int nPadLen, char* szString )
{
  unsigned int i, nLen = strlen( szString );

  for( i = nLen; i < nPadLen; i++ ) {
    szString[i] = cPad;
  }

  szString[i] = '\0';

  return( szString );
}


/*
 * char* strrepl( char* s, char* f, char* t )
 *
 */
char* strrepl( char* s, char* f, char* t )
{
  return( (char*)memrepl( s, strlen(s), f, strlen(f), t, strlen(f) ) );
}

/*
 * void* memrepl( char* s, char* f, char* t )
 *
 */
void* memrepl( void* s, unsigned int s_len,
    void* f, unsigned int f_len,
    void* t, unsigned int t_len )
{
  char* tmp = new char[s_len], *from = tmp, *to = (char*)s, *_f = (char*)f;

  if( NULL == tmp ) {
    // mem alloc failure...
    return( NULL );
  }

  memcpy( tmp, s, s_len );

  while( s_len-- ) {
    if( *from == *_f ) {
      if( 0 == memcmp( from, _f, f_len ) ) {
        memcpy( to, t, t_len );
        to += t_len;
        continue;
      }
    }

    *to++ = *from++;
  }

  delete [] tmp;
  return((void*)s);
}


char* strupper( char* s ) 
{
  char* p = s;

  while( '\0' != *p ) {
    *p = toupper(*p);
    p++;
  }

  return(s);
}
