#ifdef IGNORE_ME
  #define ident "@(#) test_tree_utils.cc (/sccs/ri_util/test/s.test_tree_utils.cc) 1.1 02/24/99 14:20:46";
#endif

/*
 * test function(s) for the tree_utils.h functions...
 *
 */

#include <iostream.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include <c_string.h>
#include <c_multi_tree.h>
#include <tree_utils.h>
#include <tree_parser.h>

char* bin     = (char*)"<no name>";
char* optstr  = (char*)"hi:";
char* file    = (char*)NULL;


int dump_tree( c_multi_tree_manipulator<c_string,c_string>& handle );
void show_usage(void);

int main( int argc, char** argv )
{
  char sw;
  bin = *argv;

  while( -1 != (sw = getopt(argc,argv,optstr)) ) { 
    switch(sw) {
			case 'i':
				file = strdup(optarg);
				INFO(cout) << "Will read tree from: " << file << endl;
				break;
      case 'h':
        show_usage();
        break;
      case '?':
        INFO(cout) << "Error unrecognized cmdline switch, ignoring" << endl;
        break;
    }
  }

  c_multi_tree<c_string,c_string> tree;
	c_multi_tree_manipulator<c_string,c_string> handle(tree);

	if( 0 != parse_tree_file(file,tree) ) {
		ERROR(cout) << "Error, unable to process file: " << file << " : " << 
						strerror(errno) << endl;
		return 1;
	}

	INFO(cout) << "Dumping The Tree:" << endl;

	c_multi_tree_manipulator<c_string,c_string> htmp(handle);
	dump_tree(htmp);

	INFO(cout) << "running the flipper..." << endl;
	htmp.top();
	flip_keys_and_values(htmp);
	dump_tree(htmp);

	c_string key = "bull-dozed?";
	INFO(cout) << "running the const key'er... " << key << endl;
	htmp.top();
	set_constant_key(htmp,key);
	dump_tree(htmp);


	c_string val = "yep";
	INFO(cout) << "running the const val'er... " << val << endl;
	htmp.top();
	set_constant_value(htmp,val);
	dump_tree(htmp);

  return 0;
}


int dump_tree( c_multi_tree_manipulator<c_string,c_string>& handle ) 
{
  static int depth = 0;
  char leader[1024];
  char format[1024];
  char buff[1024];
  c_string key, value;
  int children;

  ++depth;

  sprintf(format,"%% %dc", 4*depth);
  sprintf(leader, format, ' ' );
  sprintf(buff,"%08d",depth);
  cout << leader << "depth:          " << buff << endl;;
  handle.get_key(key);
  cout << leader << " key:           " << key << endl;
  handle.get_value(value);
  cout << leader << " value:         " << value << endl;

  children = handle.num_children();

  cout << leader << " num children:  " << children << endl;

  for( int i = 0; i < children; ++i ) {
    handle.position(i);
    handle.down();
    dump_tree(handle);
    handle.up();
  }

  --depth;
  return FALSE;
}


void show_usage(void)
{
  cout << bin << " [opts] " << endl;
	cout << " Test code for the tree_utils set of functions." << endl;
	cout << " Ops are:" << endl;
	cout << "   -i file    specify the input (tree) file." << endl;
	cout << endl;
}
